let dappaccount = {};
const dotenv = require("dotenv");
dotenv.config();
const Hashids = require("hashids/cjs");
const encoding = [
  "a",
  "b",
  "c",
  "d",
  "e",
  "f",
  "g",
  "h",
  "i",
  "j",
  "k",
  "l",
  "m",
  "n",
  "o",
];

let { PrivateKey } = require("eosjs-ecc");
const fetch = require("isomorphic-fetch");
const { createClient } = require("@liquidapps/dapp-client");
var client;
let dspEndpt = process.env.endpoint;

dappaccount.register_both = async (email, contact, otp) => {
  try {
    const dappacc = await converttovacc(email);
    let client = await createClient({
      network: "kylin",
      httpEndpoint: dspEndpt,
      fetch: fetch,
    });
    const service = await client.service("vaccounts", process.env.contract);
    let prv_key = await PrivateKey.randomKey();
    prv_key = prv_key.toWif();
    console.log("private key ==== ", prv_key);
    const response_reg = await service.push_liquid_account_transaction(
      process.env.contract,
      prv_key,
      "regboth",
      {
        vaccount: dappacc, // process.env.user1,
        email: email,
        contact: contact,
        otp: otp,
        payload: {
          vaccount: dappacc,
        },
      }
    );
    console.log("response_reg", response_reg);
    return res.status(200).send({ message: "Successful" });
  } catch (err) {
    console.log("err response_reg", err);
    let errmsg = await errorhandler.smartcontracterr(err);
    return res.status(400).send(errmsg);
  }
};

dappaccount.verifycontact = async (contact) => {
  try {
    let resp = await axios.post(process.env.twofactregcon, {
      contact: contact,
    });
    return res.status(200).send({ message: "Successful" });
  } catch (err) {
    return res.status(400).send(err);
  }
};

dappaccount.verifyemailreg = async (email) => {
  try {
    let resp = await axios.post(process.env.twofactregemail, {
      email: email,
    });
    return res.status(200).send({ message: "Successful" });
  } catch (err) {
    return res.status(400).send(err);
  }
};

dappaccount.verifyemailreset = async (email) => {
  try {
    let resp = await axios.post(process.env.twofactlogin, {
      email: email,
    });
    return res.status(200).send({ message: "Successful" });
  } catch (err) {
    return res.status(400).send(err);
  }
};

dappaccount.recover = async (email,auth_code) => {
  try {
    const dappacc = await converttovacc(email);
    console.log("contract", process.env.contract);
    let client = await createClient({
      network: "kylin",
      httpEndpoint: dspEndpt,
      fetch: fetch,
    });
    const service = await client.service("vaccounts", process.env.contract);
    let prv_key = await PrivateKey.randomKey();
    prv_key = prv_key.toWif();
    console.log("private key ==== ", prv_key);
    const response_reg = await service.push_liquid_account_transaction(
      process.env.contract,
      prv_key,
      "confirmcode",
      {
        vaccount: dappacc,
        otp: auth_code,
        payload: {
          vaccount: dappacc,
        },
      }
    );
    console.log("resp----", response_reg);
    return res.status(200).send({ message: response_reg });
  } catch (err) {
    console.log("err", err);
    let errmsg = await errorhandler.smartcontracterr(err);
    return res.status(400).send(errmsg);
  }
};

async function converttovacc(email) {
  const hashids = new Hashids(email, 9);
  let hashsh = hashids.encode(999);
  let accname = "dap" + (await getaccname(hashsh.toLowerCase()));
  console.log("account name==", accname);
  return accname;
}

async function getaccname(data) {
  let newdata = "";
  for (let i = 0; i < data.length; i += 1) {
    if (data.charAt(i) === 0 || data.charAt(i) > 5 || data.charAt(i) === "0") {
      newdata += encoding[data.charAt(i)];
    } else newdata += data.charAt(i);
  }
  return newdata;
}

//dappaccount.register_both('testemail1234aa@gmail.com','1234','123');
module.exports = dappaccount;
